varying lowp vec4 v_color;
varying lowp vec4 v_outlineColor;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	highp float smoothing = 1.0/16.0;
	highp float outlineWidth = 6.0/16.0;
	highp float outerEdgeCenter = 0.5 - outlineWidth;
	highp float distance = texture2D(u_texture, v_texCoord).a;
	highp float alpha = smoothstep(outerEdgeCenter - smoothing, outerEdgeCenter + smoothing, distance);
	highp float border = smoothstep(0.5 - smoothing, 0.5 + smoothing, distance);
	gl_FragColor = vec4( mix(v_outlineColor.rgb, v_color.rgb, border),  alpha * mix(v_outlineColor.a, v_color.a , border)
	);
}
