attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec4 a_outlineColor;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_color4;

varying lowp vec4 v_color;
varying lowp vec4 v_outlineColor;
varying mediump vec2 v_texCoord;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color * u_color4;
	v_outlineColor = a_outlineColor * u_color4;
	
	vec3 greyScaleFactor = vec3(0.3,0.59,0.11);
	
	float greyColor = dot(v_color.rgb, greyScaleFactor);
	float outlineGreyColor = dot(v_outlineColor.rgb, greyScaleFactor);
	
	v_color = vec4(vec3(greyColor), 1.0);
	v_outlineColor = vec4(vec3(outlineGreyColor), 1.0);

	v_texCoord = a_texCoord;
}
