attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;
attribute mediump vec4 a_texCoord2; // xy coord are world scale transforms, zw coords are bump pattern tile origin
attribute mediump float a_tileSelected;

attribute lowp vec4 a_topColor;
attribute lowp vec4 a_bottomColor;
attribute lowp vec4 a_middleColor;

uniform highp mat4 u_modelViewProjectionMatrix;

varying mediump vec4 v_texCoord; 	// xy coords are color texture coord, zw coord are world scale transforms
varying mediump vec3 v_texOrigin;  	// xy are bump pattern tile origin, z is random start for tiles

varying lowp vec4 v_topColor; 
varying lowp vec4 v_bottomColor; 
varying lowp vec4 v_middleColor; 

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_texCoord.xy = a_texCoord;
	v_texCoord.zw = a_texCoord2.xy;
	v_texOrigin.xy = a_texCoord2.zw;
	v_texOrigin.z = a_tileSelected;

	v_topColor = a_topColor;
	v_bottomColor = a_bottomColor;
	v_middleColor = a_middleColor;
}