varying lowp vec4 v_color;
varying lowp vec4 v_outlineColor;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	lowp vec3 v_shadowColor = vec3 (84.0/255.0, 84.0/255.0, 84.0/255.0);
	highp float outerEdgeCenter = 8.0/16.0;
	highp float smoothing = 1.0/16.0;
	highp float dist = texture2D(u_texture, v_texCoord).a;
	highp float shadowStrength = 3.0 * dist * dist;
	highp vec4 shadowColor = vec4(v_shadowColor, shadowStrength);
	shadowColor.a *= v_color.a;
	gl_FragColor =  mix(shadowColor, v_color, smoothstep(outerEdgeCenter - smoothing, outerEdgeCenter + smoothing, dist));
}
